VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cRegisterEventSource"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' ************************************************************
' Copyright  1996-2001 Slightly Tilted Software
' All rights reserved
' You're absolutely free to use these resources within your
'     own applications, but you may not redistribute them
'     (as source) in any manner whatsoever, whether for profit
'     or not.
' The only legitimate source for the original source code is
'     at the VBPJ site and my own web site at:
'     http://www.SlightlyTiltedSoftware.com
' ************************************************************

' ---------------------------------------------
' Module    : RegSrc.cls
' By        : L.J. Johnson       Date: 04-28-2001
' Comments  : Register the message resource DLL
'           : found in the app directory in the
'           : appropriate location in the registry
' ---------------------------------------------
Option Explicit

' ---------------------------------------------
' Used to return errors from RegisterEvntSource
' ---------------------------------------------
Private m_lngErrNum                    As Long
Private m_strErrSource                 As String
Private m_strErrDesc                   As String

' ---------------------------------------------
' Used in RegCreateKeyEx API call
' ---------------------------------------------
Private Type SECURITY_ATTRIBUTES
   Length                              As Long
   SecurityDescriptor                  As Long
   InheritHandle                       As Long
End Type

Private Type FILETIME
   dwLowDateTime                       As Long
   dwHighDateTime                      As Long
End Type

' ---------------------------------------------
' Declare the API calls to Open, Close, Create, and
'   Set Values in the registry
' ---------------------------------------------
Private Declare Function RegOpenKeyEx _
   Lib "advapi32" Alias "RegOpenKeyExA" _
   (ByVal hKey As Long, _
    ByVal lpSubKey As String, _
    ByVal ulOptions As Long, _
    ByVal samDesired As Long, _
    phkResult As Long) As Long
Private Declare Function RegCloseKey _
   Lib "advapi32" _
   (ByVal hKey As Long) As Long
Private Declare Function RegCreateKeyEx _
   Lib "advapi32" Alias "RegCreateKeyExA" _
   (ByVal hKey As Long, _
    ByVal lpSubKey As String, _
    ByVal Reserved As Long, _
    ByVal lpClass As String, _
    ByVal dwOptions As Long, _
    ByVal samDesired As Long, _
    lpSecurityAttributes As SECURITY_ATTRIBUTES, _
    phkResult As Long, _
    lpdwDisposition As Long) As Long
Private Declare Function RegDeleteKey _
   Lib "advapi32.dll" Alias "RegDeleteKeyA" _
   (ByVal hKey As Long, _
    ByVal lpSubKey As String) As Long
Private Declare Function RegEnumKeyEx _
   Lib "advapi32.dll" Alias "RegEnumKeyExA" _
   (ByVal hKey As Long, _
    ByVal dwIndex As Long, _
    ByVal lpName As String, _
    lpcbName As Long, _
    ByVal lpReserved As Long, _
    ByVal lpClass As String, _
    lpcbClass As Long, _
    lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegEnumKey _
   Lib "advapi32.dll" Alias "RegEnumKeyA" _
   (ByVal hKey As Long, _
    ByVal dwIndex As Long, _
    ByVal lpName As String, _
    ByRef cbname As Long) As Long
Private Declare Function RegSetValueEx _
   Lib "advapi32" Alias "RegSetValueExA" _
   (ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal Reserved As Long, _
    ByVal dwType As Long, _
    lpData As Any, _
    ByVal cbData As Long) As Long
Private Declare Function RegFlushKey _
   Lib "advapi32.dll" _
   (ByVal hKey As Long) As Long
Private Declare Function RegQueryValueEx _
   Lib "advapi32.dll" Alias "RegQueryValueExA" _
   (ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    lpData As Any, _
    lpcbData As Long) As Long

' ---------------------------------------------
' Used in setting registry values
' ---------------------------------------------
Private Const REG_NONE                 As Long = 0&   ' No value type
Private Const REG_SZ                   As Long = 1&   ' Unicode nul terminated string
Private Const REG_EXPAND_SZ            As Long = 2&   ' Unicode nul terminated string (with environment variable references)
Private Const REG_BINARY               As Long = 3    ' Free form binary
Private Const REG_DWORD                As Long = 4&   ' 32-bit number
Private Const REG_DWORD_LITTLE_ENDIAN  As Long = 4&   ' 32-bit number (same as REG_DWORD)
Private Const REG_DWORD_BIG_ENDIAN     As Long = 5&   ' 32-bit number
Private Const REG_LINK                 As Long = 6&   ' Symbolic Link (unicode)
Private Const REG_MULTI_SZ             As Long = 7&   ' Multiple Unicode strings
Private Const REG_RESOURCE_LIST        As Long = 8&   ' Resource list in the resource map
Private Const REG_FULL_RESOURCE_DESCRIPTOR   As Long = 9&   ' Resource list in the hardware description
Private Const REG_RESOURCE_REQUIREMENTS_LIST As Long = 10   '

' ---------------------------------------------
' Read/Write permissions:
' ---------------------------------------------
Private Const KEY_QUERY_VALUE          As Long = &H1&
Private Const KEY_SET_VALUE            As Long = &H2&
Private Const KEY_CREATE_SUB_KEY       As Long = &H4&
Private Const KEY_ENUMERATE_SUB_KEYS   As Long = &H8&
Private Const KEY_NOTIFY               As Long = &H10&
Private Const KEY_CREATE_LINK          As Long = &H20&
Private Const READ_CONTROL             As Long = &H20000
Private Const WRITE_DAC                As Long = &H40000
Private Const WRITE_OWNER              As Long = &H80000
Private Const SYNCHRONIZE              As Long = &H100000
Private Const STANDARD_RIGHTS_REQUIRED As Long = &HF0000
Private Const STANDARD_RIGHTS_READ     As Long = READ_CONTROL
Private Const STANDARD_RIGHTS_WRITE    As Long = READ_CONTROL
Private Const STANDARD_RIGHTS_EXECUTE  As Long = READ_CONTROL
Private Const KEY_READ                 As Long = STANDARD_RIGHTS_READ Or _
                                                 KEY_QUERY_VALUE Or _
                                                 KEY_ENUMERATE_SUB_KEYS Or _
                                                 KEY_NOTIFY
Private Const KEY_WRITE                As Long = STANDARD_RIGHTS_WRITE Or _
                                                 KEY_SET_VALUE Or _
                                                 KEY_CREATE_SUB_KEY
Private Const KEY_EXECUTE              As Long = KEY_READ

' ---------------------------------------------
' Used by RegCreateKeyEx API function
' ---------------------------------------------
Private Const REG_OPTION_NON_VOLATILE  As Long = 0&
Private Const HKEY_LOCAL_MACHINE       As Long = &H80000002

Private Const EVENTLOG_ERROR_TYPE      As Long = 1&
Private Const EVENTLOG_WARNING_TYPE    As Long = 2&
Private Const EVENTLOG_INFORMATION_TYPE   As Long = 4&

' ---------------------------------------------
' Used as part of error string return
' ---------------------------------------------
Private Const REG_SOURCENAME           As String = "WriteEvents.RegisterEvntSource."

' *******************************************************
' Routine Name : (FRIEND in CLASS) Function GetLogNames
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/28/2001 -- 18:05:15
' Inputs       : N/A
' Outputs      : Variant --
' Description  : Get the names of the event logs available
'              :     on this system
'              : Applies to W2K+
' Called By    : *****
' *******************************************************
Friend Function GetLogNames() As Variant
   Dim p_lngRtn                        As Long
   Dim p_lngLenKeyName                 As Long
   Dim p_lngIndex                      As Long
   Dim p_lngNumItems                   As Long
   Dim p_lngKeyHandle                  As Long
   Dim p_strKeyName                    As String
   Dim p_strSubKey                     As String
   Dim p_typLastWriteTime              As FILETIME
   Dim p_vntNames()                    As Variant
   
   Const BASE_DIR                      As String = "System\CurrentControlSet\Services\EventLog"
   Const NO_MORE_ITEMS                 As Long = 259&
   
   ' ------------------------------------------
   ' Set the full subkey name
   ' ------------------------------------------
   p_strSubKey = BASE_DIR

   ' ------------------------------------------
   ' Open the key so we can enumerate it's keys
   ' ------------------------------------------
   p_lngRtn = RegOpenKeyEx(hKey:=HKEY_LOCAL_MACHINE, _
                           lpSubKey:=p_strSubKey, _
                           ulOptions:=0&, _
                           samDesired:=KEY_READ, _
                           phkResult:=p_lngKeyHandle)
   If p_lngRtn <> ERROR_SUCCESS Then
      m_lngErrNum = (ERR_NO_OPEN_KEY + vbObjectError)
      m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
      m_strErrDesc = "Could not OPEN the list of event log names in " & _
                         BASE_DIR & ".  The error was: " & _
                         ReturnApiErrString(p_lngRtn)
      Exit Function
   End If

   ' ------------------------------------------
   ' Now, enumerate them
   ' ------------------------------------------
   Do
      p_lngLenKeyName = 255
      p_strKeyName = String$(p_lngLenKeyName, 0)
      p_lngRtn = RegEnumKey(hKey:=p_lngKeyHandle, _
                            dwIndex:=p_lngIndex, _
                            lpName:=p_strKeyName, _
                            cbname:=p_lngLenKeyName)
      
      If p_lngRtn = NO_MORE_ITEMS Then
         GetLogNames = p_vntNames
         GoTo CloseKey
      
      ElseIf p_lngRtn = ERROR_SUCCESS Then
         ReDim Preserve p_vntNames(0 To p_lngNumItems)
         p_vntNames(p_lngNumItems) = Mid$(p_strKeyName, 1, p_lngLenKeyName)
         p_lngNumItems = p_lngNumItems + 1
         p_lngIndex = p_lngIndex + 1
      Else
         m_lngErrNum = (Err.LastDllError + vbObjectError)
         m_strErrSource = REG_SOURCENAME & "GetLogName"
         m_strErrDesc = "Error retriving event log names, " & _
                            ReturnApiErrString(Err.LastDllError)
         Err.Raise Number:=m_lngErrNum, _
                   Description:=m_strErrDesc, _
                   Source:=m_strErrSource
      End If

   Loop While p_lngRtn <> NO_MORE_ITEMS
   
CloseKey:
   ' ------------------------------------------
   ' Always close the key you opened
   ' ------------------------------------------
   p_lngRtn = RegCloseKey(p_lngKeyHandle)

   If p_lngRtn <> ERROR_SUCCESS Then
      m_lngErrNum = (ERR_NO_CLOSE_KEY + vbObjectError)
      m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
      m_strErrDesc = "Could not CLOSE the key, " & _
                     BASE_DIR & ".  The error was: " & _
                     ReturnApiErrString(p_lngRtn)
   End If

End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Sub UnRegisterEventSource
' Written By   : L.J  Johnson
' Programmer   : L.J  Johnson [Slightly Tilted Software]
' Date Writen  : 05/30/2001 -- 16:42:26
' Inputs       : ByVal xi_strAppName:String - Name of app to unregister
'              : ByVal xi_strLogName:String - Name of the log to unregister under
' Outputs      : N/A
' Description  : Unregister the event source.
' *******************************************************
Public Sub UnRegisterEventSource(ByVal xi_strAppName As String, _
                                 ByVal xi_strLogName As String)
   Dim p_lngRtn                        As Long
   Dim p_strSubKey                     As String
   Const BASE_DIR                      As String = "System\CurrentControlSet\Services\EventLog\"

   ' ------------------------------------------
   ' Set the full subkey name
   ' ------------------------------------------
   p_strSubKey = BASE_DIR & xi_strLogName & "\" & xi_strAppName

   ' ----------------------------------------------
   ' Delete the key
   ' ----------------------------------------------
   p_lngRtn = RegDeleteKey(hKey:=HKEY_LOCAL_MACHINE, _
                           lpSubKey:=p_strSubKey)
   If p_lngRtn = ERROR_SUCCESS Then
      ' Do nothing
   Else
      m_lngErrNum = (ERR_NO_CREATE_KEY + vbObjectError)
      m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
      m_strErrDesc = "Could not CREATE the key, " & xi_strAppName & _
                         ", in the registry under " & BASE_DIR & xi_strLogName & _
                         ".  The error was: " & ReturnApiErrString(p_lngRtn)
      Err.Raise m_lngErrNum, m_strErrSource, m_strErrDesc
   End If
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Sub RegisterEventSource
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/29/2001 -- 09:37:55
' Inputs       : ByVal xi_strMessageFile:String  - Name for the message file
'              : ByVal xi_strCategoryFile:String - Name for the category file
'              : ByVal xi_strFilePath:String     - Path of the dlls
'              : ByVal xi_strAppName:String      - Name of the application
'              : ByVal xi_strLogName:String      - Name of the log to register
'              : Optional ByVal xi_lngNumCategories:Long - Number of categories
' Outputs      : NA
' Description  : Register the 2 DLLs that contains the message
'              : resource and category resource info in
'              : the correct location in the 32-bit registry
' Called By    : *****
' *******************************************************
Public Sub RegisterEventSource(ByVal xi_strMessageFile As String, _
                               ByVal xi_strCategoryFile As String, _
                               ByVal xi_strFilePath As String, _
                               ByVal xi_strAppName As String, _
                               ByVal xi_strLogName As String, _
                               Optional ByVal xi_lngNumCategories As Long)
   Dim p_lngRtn                        As Long
   Dim p_lngDisposition                As Long
   Dim p_strSubKey                     As String
   Dim p_lngResKey                     As Long
   Dim p_lngKeyHandle                  As Long
   Dim p_strValData                    As String
   Dim p_lngPtrValData                 As Long
   Dim p_lngLenData                    As Long
   Dim p_strValueName                  As String
   Dim p_strMulti                      As String
   Dim p_lngLenMulti                   As Long
   Dim p_lngSuccess                    As Long
   Dim p_typSecAttrib                  As SECURITY_ATTRIBUTES
   Const BASE_DIR                      As String = "System\CurrentControlSet\Services\EventLog\"

   ' ------------------------------------------
   ' Set the full subkey name and default the
   '   return value to TRUE
   ' ------------------------------------------
   p_strSubKey = BASE_DIR & xi_strLogName & "\" & xi_strAppName

   ' ----------------------------------------------
   ' Create the key -- this will work even if the
   '   key already exists!
   ' ----------------------------------------------
   p_lngRtn = RegCreateKeyEx(hKey:=HKEY_LOCAL_MACHINE, _
                             lpSubKey:=p_strSubKey, _
                             Reserved:=0&, _
                             lpClass:="", _
                             dwOptions:=REG_OPTION_NON_VOLATILE, _
                             samDesired:=KEY_WRITE, _
                             lpSecurityAttributes:=p_typSecAttrib, _
                             phkResult:=p_lngResKey, _
                             lpdwDisposition:=p_lngDisposition)
   If p_lngRtn = ERROR_SUCCESS Then
      ' p_lngDisposition = REG_CREATED_NEW_KEY means
      '   that a new key was created --
      ' p_lngDisposition = REG_OPENED_EXISTING_KEY
      '   means that we opened an existing key.
      ' We don't care here, but it could matter in
      '   other places
      p_lngRtn = RegCloseKey(hKey:=p_lngResKey)
      
   Else
      m_lngErrNum = (ERR_NO_CREATE_KEY + vbObjectError)
      m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
      m_strErrDesc = "Could not CREATE the key, " & xi_strAppName & _
                         ", in the registry under " & BASE_DIR & xi_strLogName & _
                         ".  The error was: " & ReturnApiErrString(p_lngRtn)
      Err.Raise m_lngErrNum, m_strErrSource, m_strErrDesc
   End If

   ' ------------------------------------------
   ' Open the key so we can set 4 values
   ' ------------------------------------------
   p_lngRtn = RegOpenKeyEx(hKey:=HKEY_LOCAL_MACHINE, _
                           lpSubKey:=p_strSubKey, _
                           ulOptions:=0&, _
                           samDesired:=KEY_WRITE, _
                           phkResult:=p_lngKeyHandle)
   If p_lngRtn <> ERROR_SUCCESS Then
      m_lngErrNum = (ERR_NO_OPEN_KEY + vbObjectError)
      m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
      m_strErrDesc = "Could not OPEN the key, " & _
                         xi_strAppName & ", in the registry under " & _
                         BASE_DIR & xi_strLogName & ".  The error was: " & _
                         ReturnApiErrString(p_lngRtn)
      p_lngRtn = RegCloseKey(p_lngKeyHandle)
      Err.Raise m_lngErrNum, m_strErrSource, m_strErrDesc
   End If

   ' ------------------------------------------
   ' Set the FIRST value, EventMessageFile
   ' ------------------------------------------
   p_strValueName = "EventMessageFile"

   If Right$(Trim$(xi_strFilePath), 1) <> "\" Then
      xi_strFilePath = Trim$(xi_strFilePath) & "\"
   End If

   p_strValData = xi_strFilePath & xi_strMessageFile
   p_lngLenData = Len(p_strValData)
   p_lngRtn = RegSetValueEx(hKey:=p_lngKeyHandle, _
                            lpValueName:=p_strValueName, _
                            Reserved:=0&, _
                            dwType:=REG_EXPAND_SZ, _
                            lpData:=ByVal p_strValData, _
                            cbData:=p_lngLenData)
   If p_lngRtn <> ERROR_SUCCESS Then
      m_lngErrNum = (ERR_NO_SET_FIRST_VALUE + vbObjectError)
      m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
      m_strErrDesc = "Could not SET the EventMessageFile value for the key, " & _
                         xi_strAppName & ", in the registry under " & _
                         BASE_DIR & xi_strLogName & ".  The error was: " & _
                         ReturnApiErrString(p_lngRtn)
      p_lngRtn = RegCloseKey(p_lngKeyHandle)
      Err.Raise m_lngErrNum, m_strErrSource, m_strErrDesc
   End If

   ' ------------------------------------------
   ' Set the SECOND & THIRD values,
   '     CategoryMessageFile and CatetoryCount
   ' ------------------------------------------
   p_strValueName = "CategoryMessageFile"

   If Right$(Trim$(xi_strFilePath), 1) <> "\" Then
      xi_strFilePath = Trim$(xi_strFilePath) & "\"
   End If

   p_strValData = xi_strFilePath & xi_strCategoryFile
   p_lngLenData = Len(p_strValData)
   p_lngRtn = RegSetValueEx(hKey:=p_lngKeyHandle, _
                            lpValueName:=p_strValueName, _
                            Reserved:=0&, _
                            dwType:=REG_EXPAND_SZ, _
                            lpData:=ByVal p_strValData, _
                            cbData:=p_lngLenData)
   If p_lngRtn <> ERROR_SUCCESS Then
      m_lngErrNum = (ERR_NO_SET_FIRST_VALUE + vbObjectError)
      m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
      m_strErrDesc = "Could not SET the CategoryMessageFile value for the key, " & _
                         xi_strAppName & ", in the registry under " & _
                         BASE_DIR & xi_strLogName & ".  The error was: " & _
                         ReturnApiErrString(p_lngRtn)
      p_lngRtn = RegCloseKey(p_lngKeyHandle)
      Err.Raise m_lngErrNum, m_strErrSource, m_strErrDesc
   End If

   p_strValueName = "CategoryCount"
   
   p_lngRtn = RegSetValueEx(hKey:=p_lngKeyHandle, _
                            lpValueName:=p_strValueName, _
                            Reserved:=0&, _
                            dwType:=REG_DWORD, _
                            lpData:=xi_lngNumCategories, _
                            cbData:=Len(xi_lngNumCategories))
   If p_lngRtn <> ERROR_SUCCESS Then
      m_lngErrNum = (ERR_NO_SET_FIRST_VALUE + vbObjectError)
      m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
      m_strErrDesc = "Could not SET the CategoryCount value for the key, " & _
                         xi_strAppName & ", in the registry under " & _
                         BASE_DIR & xi_strLogName & ".  The error was: " & _
                         ReturnApiErrString(p_lngRtn)
      p_lngRtn = RegCloseKey(p_lngKeyHandle)
      Err.Raise m_lngErrNum, m_strErrSource, m_strErrDesc
   End If

   ' ------------------------------------------
   ' Set the FOURTH value, TypesSupported
   ' ------------------------------------------
   p_strValueName = "TypesSupported"
   
   p_lngPtrValData = EVENTLOG_ERROR_TYPE Or _
                     EVENTLOG_WARNING_TYPE Or _
                     EVENTLOG_INFORMATION_TYPE
   p_lngLenData = Len(p_lngPtrValData)
   p_lngRtn = RegSetValueEx(hKey:=p_lngKeyHandle, _
                            lpValueName:=p_strValueName, _
                            Reserved:=0&, _
                            dwType:=REG_DWORD, _
                            lpData:=p_lngPtrValData, _
                            cbData:=p_lngLenData)
   If p_lngRtn <> ERROR_SUCCESS Then
      m_lngErrNum = (ERR_NO_SET_SECOND_VALUE + vbObjectError)
      m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
      m_strErrDesc = "Could not SET the TypesSupported value for the key, " & _
                         xi_strAppName & ", in the registry under " & _
                         BASE_DIR & xi_strLogName & ".  The error was: "
                         ReturnApiErrString (p_lngRtn)
      p_lngRtn = RegCloseKey(p_lngKeyHandle)
      Err.Raise m_lngErrNum, m_strErrSource, m_strErrDesc
   End If
   
   ' ------------------------------------------
   ' Always close the key you opened
   ' ------------------------------------------
   p_lngRtn = RegFlushKey(p_lngKeyHandle)
   p_lngRtn = RegCloseKey(p_lngKeyHandle)
   If p_lngRtn <> ERROR_SUCCESS Then
      m_lngErrNum = (ERR_NO_CLOSE_KEY + vbObjectError)
      m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
      m_strErrDesc = "Could not CLOSE the key, " & _
                         xi_strAppName & ", in the registry under " & _
                         BASE_DIR & xi_strLogName & ".  The error was: " & _
                         ReturnApiErrString(p_lngRtn)
      '### Err.Raise m_lngErrNum, m_strErrSource, m_strErrDesc
   End If

' As per Richard Grimes, you not only don't need
'     to do this, manually adding items to 'Sources'
'     can have bad effects...
'
'
'   ' ------------------------------------------
'   ' Reset the subkey, then open it
'   ' ------------------------------------------
'   p_strSubKey = BASE_DIR & xi_strLogName
'
'   p_lngRtn = RegOpenKeyEx(hKey:=HKEY_LOCAL_MACHINE, _
'                           lpSubKey:=p_strSubKey, _
'                           ulOptions:=0&, _
'                           samDesired:=KEY_WRITE Or KEY_READ, _
'                           phkResult:=p_lngKeyHandle)
'   If p_lngRtn <> ERROR_SUCCESS Then
'      m_lngErrNum = (ERR_NO_OPEN_KEY + vbObjectError)
'      m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
'      m_strErrDesc = "Could not OPEN the key, " & p_strSubKey & _
'                         ", in the registry" & ".  The error was: " & _
'                         ReturnApiErrString(p_lngRtn)
'      p_lngRtn = RegCloseKey(p_lngKeyHandle)
'      Err.Raise m_lngErrNum, m_strErrSource, m_strErrDesc
'   End If
'
'   ' ------------------------------------------
'   ' Get the current values for 'Sources'
'   ' ------------------------------------------
'   p_strMulti = Space$(1024 * 10)
'   p_lngLenMulti = Len(p_strMulti)
'   p_lngRtn = RegQueryValueEx(hKey:=p_lngKeyHandle, _
'                              lpValueName:="Sources", _
'                              lpReserved:=0&, _
'                              lpType:=REG_MULTI_SZ, _
'                              lpData:=ByVal p_strMulti, _
'                              lpcbData:=p_lngLenMulti)
'   If p_lngRtn <> ERROR_SUCCESS Then
'      m_lngErrNum = (ERR_NO_OPEN_KEY + vbObjectError)
'      m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
'      m_strErrDesc = "Could not OPEN the key, " & p_strSubKey & _
'                         ", in the registry" & ".  The error was: " & _
'                         ReturnApiErrString(p_lngRtn)
'      p_lngRtn = RegCloseKey(p_lngKeyHandle)
'      Err.Raise m_lngErrNum, m_strErrSource, m_strErrDesc
'
'   Else
'      p_strMulti = Left$(p_strMulti, p_lngLenMulti)
'      p_lngSuccess = SetMultiString(p_strMulti, xi_strAppName)
'   End If
'
'   ' ------------------------------------------
'   ' Set the registry value for Multi
'   ' ------------------------------------------
'   If p_lngSuccess = True Then
'      p_strValueName = "Sources"
'      p_strValData = p_strMulti
'      p_lngLenData = Len(p_strValData)
'
'      p_lngRtn = RegSetValueEx(hKey:=p_lngKeyHandle, _
'                               lpValueName:=p_strValueName, _
'                               Reserved:=0&, _
'                               dwType:=REG_MULTI_SZ, _
'                               lpData:=ByVal p_strValData, _
'                               cbData:=p_lngLenData)
'      If p_lngRtn <> ERROR_SUCCESS Then
'         m_lngErrNum = (ERR_NO_SET_FIRST_VALUE + vbObjectError)
'         m_strErrSource = REG_SOURCENAME & "RegisterEventSource"
'         m_strErrDesc = "Could not SET the EventMessageFile value for the key, " & _
'                            xi_strAppName & ", in the registry under " & _
'                            BASE_DIR & xi_strLogName & ".  The error was: " & _
'                            ReturnApiErrString(p_lngRtn)
'         p_lngRtn = RegCloseKey(p_lngKeyHandle)
'         Err.Raise m_lngErrNum, m_strErrSource, m_strErrDesc
'      End If
'   End If

   ' ------------------------------------------
   ' Flush it
   ' ------------------------------------------
   If p_lngSuccess = True Then
      p_lngRtn = RegFlushKey(p_lngKeyHandle)
   End If
   
End Sub

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Function SetMultiString
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 04/28/2001 -- 11:17:34
' Inputs       : ByRef xio_strMulti:String -
'              : ByVal xi_strAppName:String -
' Outputs      : Boolean --
' Description  : Parses the original string
'              : (null-delimited), adds the passed
'              : xi_strAppName to the original string
'              : if it doesn't exist within that string
' Called By    : RegisterEventSource
' *******************************************************
Private Function SetMultiString(ByRef xio_strMulti As String, _
                                ByVal xi_strAppName As String) As Boolean
   Dim p_lngStartPos                   As Long
   Dim p_lngEndPos                     As Long
   Dim p_blnFound                      As Boolean
   Dim p_strTmp                        As String
   
   On Error Resume Next
   p_blnFound = False
   p_lngStartPos = 1
   
   Do
      p_lngEndPos = InStr(p_lngStartPos, xio_strMulti, Chr$(0))
      
      If p_lngEndPos = 0 Then
         Exit Do
      End If
      
      If p_lngEndPos > 0 Then
         p_strTmp = Mid$(xio_strMulti, p_lngStartPos, (p_lngEndPos - p_lngStartPos))
      End If
   
      If UCase$(Trim$(p_strTmp)) = UCase$(Trim$(xi_strAppName)) Then
         p_blnFound = True
         Exit Do
      End If
      
      p_lngStartPos = p_lngEndPos + 1
   
   Loop While p_lngStartPos > 0
   
   If p_blnFound = False Then
      SetMultiString = True
      xio_strMulti = Mid$(xio_strMulti, 1, Len(xio_strMulti) - 1) & xi_strAppName$ & Chr$(0) & Chr$(0)
   Else
      SetMultiString = False
   End If
   
   On Error GoTo 0
End Function
